zoukankan      html  css  js  c++  java
  • Super Jumping! Jumping! Jumping!

    Description
    Nowadays, a kind of chess game called “Super Jumping! Jumping! Jumping!” is very popular in HDU. Maybe you are a good boy, and know little about this game, so I introduce it to you now.



    The game can be played by two or more than two players. It consists of a chessboard(棋盘)and some chessmen(棋子), and all chessmen are marked by a positive integer or “start” or “end”. The player starts from start-point and must jumps into end-point finally. In the course of jumping, the player will visit the chessmen in the path, but everyone must jumps from one chessman to another absolutely bigger (you can assume start-point is a minimum and end-point is a maximum.). And all players cannot go backwards. One jumping can go from a chessman to next, also can go across many chessmen, and even you can straightly get to end-point from start-point. Of course you get zero point in this situation. A player is a winner if and only if he can get a bigger score according to his jumping solution. Note that your score comes from the sum of value on the chessmen in you jumping path.
    Your task is to output the maximum value according to the given chessmen list.
    Input
    Input contains multiple test cases. Each test case is described in a line as follow:
    N value_1 value_2 …value_N
    It is guarantied that N is not more than 1000 and all value_i are in the range of 32-int.
    A test case starting with 0 terminates the input and this test case is not to be processed.
    Output
    For each case, print the maximum according to rules, and one line one case.
    SampleInput
    3 1 3 2
    4 1 2 3 4
    4 3 3 2 1
    0
    SampleOutput
    4
    10
    3
    解释一下题意:此题就是找序列中最大升序子序列的和。
    比如  1 3 2 中升序序列有:{1}{3}{2}{1,3}{1,2}。所以最大为1+3=4;
     
    dp[i]表示以i结尾的升序子序列的最大和,所以最后要比较所有的dp[i]。
    用两个循环第一个循环(i)指定第i个元素a[i]
    第二个循环(j)从头开始找如果a[i]>a[j] 就令dp[j]暂时为前段的最大值dns
    继续向后找如果再次a[i]>a[j]则需比较dp[j]与dns的大小即max(dp[j],dns)找到新的dns
    直到j为i前面的那个元素循环结束 dp[i]=ans+a[i]
     
     1 #include <iostream>
     2 #include <stdio.h>
     3 #include <string.h>
     4 #include <algorithm>
     5 using namespace std;
     6 
     7 int max(int x,int y){
     8     return x>y?x:y;
     9 }
    10 int a[1005],dp[1005];
    11 const int inf = 999999999;        //-inf表示最小的整数
    12 
    13 int main()
    14 {
    15     int n,i,t,m,j,ans;
    16     while(cin>>n,n)
    17     {
    18         memset(dp,0,sizeof(dp));
    19         for(i = 1;i<=n;i++)
    20         cin>>a[i];
    21         for(i = 1;i<=n;i++)
    22         {
    23             ans = -999;
    24             for(j = 0;j<i;j++)
    25             {
    26                 if(a[i]>a[j])
    27                 ans = max(ans,dp[j]);
    28             }
    29             dp[i] = ans+a[i];
    30         }
    31         ans = -999;
    32         for(i = 0;i<=n;i++)
    33         {
    34             if(dp[i]>ans)
    35             ans = dp[i];
    36         }
    37         cout<<ans<<endl;
    38     }
    39 
    40     return 0;
    41 }
    View Code
  • 相关阅读:
    面试官:反射都不会,还敢说自己会Java?
    nginx 开启x-forward
    不写代码,从0到1教你制作炫酷可视化大屏
    5G 专网部署方案
    Mac运行pygame一直显示空白屏幕
    数据库大咖解读“新基建”,墨天轮四重好礼相送!
    Oracle 20c 新特性:自动的区域图
    4000多人全靠报表自动化,效率提高60%,这套数据平台方法论真强
    EBS开发性能优化之查找需要优化的程序
    EBS开发性能优化之SQL语句优化
  • 原文地址:https://www.cnblogs.com/to-creat/p/4891140.html
Copyright © 2011-2022 走看看